<?php
/**********************************************************************
***********************************************************************/
$path_to_root = "..";
$page_security = 'SA_PURCHASEORDER';
include_once($path_to_root . "/purchasing/includes/po_class.inc");
include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/purchasing/includes/ui/purchasing_ui.inc");
include_once($path_to_root . "/purchasing/includes/db/suppliers_db.inc");
include_once($path_to_root . "/purchasing/includes/purchasing_db.inc");
include_once($path_to_root . "/reporting/includes/reporting.inc");

include_once($path_to_root . "/includes/approval_functions.inc");
include_once($path_to_root . "/includes/project_cost_functions.inc");
include_once($path_to_root . "/inventory/includes/db/alternate_units_db.inc");
include_once($path_to_root . "/projects/includes/db/project_sites_db.inc");


set_page_security( @$_SESSION['PO']->trans_type,
	array(	ST_PURCHORDER => 'SA_PURCHASEORDER',
			ST_SUPPRECEIVE => 'SA_GRN',
			ST_SUPPINVOICE => 'SA_SUPPLIERINVOICE'),
	array(	'NewOrder' => 'SA_PURCHASEORDER',
			'ModifyOrderNumber' => 'SA_PURCHASEORDER',
			'AddedID' => 'SA_PURCHASEORDER',
			'NewGRN' => 'SA_GRN',
			'AddedGRN' => 'SA_GRN',
			'NewInvoice' => 'SA_SUPPLIERINVOICE',
			'AddedPI' => 'SA_SUPPLIERINVOICE')
);

$js = '';
if ($SysPrefs->use_popup_windows)
	$js .= get_js_open_window(900, 500);
if (user_use_date_picker())
	$js .= get_js_date_picker();

if (isset($_GET['ModifyOrderNumber']) && is_numeric($_GET['ModifyOrderNumber'])) {

	$_SESSION['page_title'] = _($help_context = "Modify Purchase Order #") . $_GET['ModifyOrderNumber'];
	create_new_po(ST_PURCHORDER, $_GET['ModifyOrderNumber']);
	copy_from_cart();
} elseif (isset($_GET['NewOrder'])) {

	$_SESSION['page_title'] = _($help_context = "Purchase Order Entry");
	create_new_po(ST_PURCHORDER, 0);
	copy_from_cart();
} elseif (isset($_GET['NewGRN'])) {

	$_SESSION['page_title'] = _($help_context = "Direct GRN Entry");
	create_new_po(ST_SUPPRECEIVE, 0);
	copy_from_cart();
} elseif (isset($_GET['NewInvoice'])) {

	$_SESSION['page_title'] = _($help_context = "Direct Purchase Invoice Entry");
	create_new_po(ST_SUPPINVOICE, 0);
	copy_from_cart();
}

page($_SESSION['page_title'], false, false, "", $js);

//---------------------------------------------------------------------------------------------------

check_db_has_suppliers(_("There are no suppliers defined in the system."));

check_db_has_purchasable_items(_("There are no purchasable inventory items defined in the system."));

//---------------------------------------------------------------------------------------------------------------

if (isset($_GET['AddedID'])) 
{
	$order_no = $_GET['AddedID'];
	$trans_type = ST_PURCHORDER;	

	if (!isset($_GET['Updated'])){
		display_notification_centered(_("Purchase Order #$order_no has been created"));
    }
	else{
		display_notification_centered(_("Purchase Order #".$order_no." has been updated"));
        if(isset($_SESSION['po_messages'])){
            $result = get_session_variable('po_messages');
            if($result['success'] === true){
                display_notification_centered($result['message']);
            }
            else{
                display_error($result['message']);
            }
            clear_session_variable('po_messages');
            br();
        }
    }

        
	display_note(get_trans_view_str($trans_type, $order_no, _("&View this order")), 0, 1);

	display_note(print_document_link($order_no, _("&Print This Order"), true, $trans_type), 0, 1);

	//display_note(print_document_link($order_no, _("&Email This Order"), true, $trans_type, false, "printlink", "", 1));

	hyperlink_params($path_to_root . "/purchasing/po_receive_items.php", _("&Receive Items on this Purchase Order"), "PONumber=$order_no");

	hyperlink_params($_SERVER['PHP_SELF'], _("Enter &Another Purchase Order"), "NewOrder=yes");
	
	hyperlink_no_params($path_to_root."/purchasing/inquiry/po_search.php", _("Select An &Outstanding Purchase Order"));
	
	display_footer_exit();	

} elseif (isset($_GET['AddedGRN'])) {

	$trans_no = $_GET['AddedGRN'];
	$trans_type = ST_SUPPRECEIVE;

	display_notification_centered(_("Direct GRN has been entered"));

	display_note(get_trans_view_str($trans_type, $trans_no, _("&View this GRN")), 0);

    $clearing_act = get_company_pref('grn_clearing_act');
	if ($clearing_act)	
		display_note(get_gl_view_str($trans_type, $trans_no, _("View the GL Journal Entries for this Delivery")), 1);
// not yet
//	display_note(print_document_link($trans_no, _("&Print This GRN"), true, $trans_type), 0, 1);

	hyperlink_params("$path_to_root/purchasing/supplier_invoice.php",
		_("Entry purchase &invoice for this receival"), "New=1");

	hyperlink_params("$path_to_root/admin/attachments.php", _("Add an Attachment"), 
		"filterType=$trans_type&trans_no=$trans_no");

	hyperlink_params($_SERVER['PHP_SELF'], _("Enter &Another GRN"), "NewGRN=Yes");
	
	display_footer_exit();	

} elseif (isset($_GET['AddedPI'])) {

	$trans_no = $_GET['AddedPI'];
	$trans_type = ST_SUPPINVOICE;

	display_notification_centered(_("Direct Purchase Invoice has been entered"));

	display_note(get_trans_view_str($trans_type, $trans_no, _("&View this Invoice")), 0);

// not yet
//	display_note(print_document_link($trans_no, _("&Print This Invoice"), true, $trans_type), 0, 1);

	display_note(get_gl_view_str($trans_type, $trans_no, _("View the GL Journal Entries for this Invoice")), 1);

	hyperlink_params("$path_to_root/purchasing/supplier_payment.php", _("Entry supplier &payment for this invoice"),
		"PInvoice=".$trans_no);

	hyperlink_params("$path_to_root/admin/attachments.php", _("Add an Attachment"), 
		"filterType=$trans_type&trans_no=$trans_no");

	hyperlink_params($_SERVER['PHP_SELF'], _("Enter &Another Direct Invoice"), "NewInvoice=Yes");
	
	display_footer_exit();	
}
//--------------------------------------------------------------------------------------------------

function line_start_focus() {
  global 	$Ajax;

  $Ajax->activate('items_table');
  set_focus('_stock_id_edit');
}
//--------------------------------------------------------------------------------------------------

function unset_form_variables() {
	unset($_POST['stock_id']);
    unset($_POST['qty']);
    unset($_POST['price']);
    unset($_POST['order_unit_price']);
    unset($_POST['req_del_date']);
    unset($_POST['project_site_id']);
    unset($_POST['order_unit_price_discount']);
    unset($_POST['minimum_price']);
    unset($_POST['minimum_price_discount']);
    unset($_POST['min_price_supplier_id']);
}

//---------------------------------------------------------------------------------------------------

function handle_delete_item($line_no)
{
	if($_SESSION['PO']->some_already_received($line_no) == 0)
	{
		$_SESSION['PO']->remove_from_order($line_no);
		unset_form_variables();
	} 
	else 
	{
		display_error(_("This item cannot be deleted because some of it has already been received."));
	}	
    line_start_focus();
}

//---------------------------------------------------------------------------------------------------

function handle_cancel_po()
{
	global $path_to_root;
	
    /*
	//need to check that not already dispatched or invoiced by the supplier
	if(($_SESSION['PO']->order_no != 0) && 
		$_SESSION['PO']->any_already_received() == 1)
	{
		display_error(_("This order cannot be cancelled because some of it has already been received.") 
			. "<br>" . _("The line item quantities may be modified to quantities more than already received. prices cannot be altered for lines that have already been received and quantities cannot be reduced below the quantity already received."));
		return;
	}
	
	if($_SESSION['PO']->order_no != 0)
	{
		delete_po($_SESSION['PO']->order_no);
	} else {
		unset($_SESSION['PO']);
		meta_forward($path_to_root.'/index.php','application=AP');
	}
     * 
     */

	$_SESSION['PO']->clear_items();
	$_SESSION['PO'] = new purch_order;

	//display_notification(_("This purchase order has been cancelled."));

	hyperlink_params($path_to_root . "/purchasing/po_entry_items.php", _("Enter a new purchase order"), "NewOrder=Yes");
	echo "<br>";

	end_page();
	exit;
}

//---------------------------------------------------------------------------------------------------

function check_data()
{
	if(strlen(get_post('stock_id')) == 0) {
		display_error( _("No item selected."));
		set_focus('stock_id');
		return false;
	}
    
        if(!get_post('stock_id_text', true)) {
		display_error( _("Item description cannot be empty."));
		set_focus('stock_id');
		return false;
	}
        
        if(!(strlen(get_post('tran_unit')) > 0)) {
		display_error( _("No unit selected."));
		set_focus('tran_unit');
		return false;
	}

	$dec = get_qty_dec($_POST['stock_id']);
	$min = 1 / pow(10, $dec);
        if (!check_num('tran_qty',$min))
        {
                $min = number_format2($min, $dec);
                display_error(_("The quantity of the order item must be numeric and not less than ").$min);
                set_focus('tran_qty');
                return false;
        }

        if (!check_num('order_unit_price', 0))
        {
                display_error(_("The price entered must be numeric and not less than zero."));
                set_focus('order_unit_price');
                return false;	   
        }
        if ($_SESSION['PO']->trans_type == ST_PURCHORDER && !is_date($_POST['req_del_date'])){
                display_error(_("The date entered is in an invalid format."));
                set_focus('req_del_date');
                return false;    	 
        }
    
//      if(!(get_post('project_site_id') > 0)) {
//		display_error( _("Please select a Site."));
//		set_focus('project_site_id');
//		return false;
//	}
    
        if (!check_num('order_unit_price_discount', 0, 100))
        {
                    display_error(_("The Discount entered must be numeric and between 0 and 100."));
                    set_focus('order_unit_price');
                    return false;	   
        }
    
//        $ietm = get_item($_POST['stock_id']);
//        if($ietm['any_supplier'] == false){
//            $purchasing_data = get_suppliers_purchasing_data($_POST['stock_id'], $_POST['supplier_id']);
//
//            if($purchasing_data == null){
//                display_error(_("Selected item is not difined for current suppler."));
//                set_focus('stock_id');
//                return false; 
//            }
//        }
     
    return true;	
}

//---------------------------------------------------------------------------------------------------

function handle_update_item()
{
        $allow_update = check_data();
        if(!$allow_update){
                $_POST['Edit'.get_post('line_no')] = 1;
                return;
        }    
        $po_cart = $_SESSION['PO'];
        $id = $_POST['line_no'];
        $stock_id = $po_cart->line_items[$id]->stock_id;
        $tran_unit = $po_cart->line_items[$id]->tran_unit;
        get_convertion_factor2($stock_id, $tran_unit, $convesion_factor);
        $po_cart->line_items[$id]->tran_unit = $tran_unit;
        
	if ($allow_update)
	{
		if ($po_cart->line_items[$id]->qty_inv > input_num('tran_qty')*$convesion_factor ||
			$po_cart->line_items[$id]->qty_received > input_num('tran_qty')*$convesion_factor)
		{
			display_error(_("You are attempting to make the quantity ordered a quantity less than has already been invoiced or received.  This is prohibited.") .
				"<br>" . _("The quantity received can only be modified by entering a negative receipt and the quantity invoiced can only be reduced by entering a credit note against this item."));
			set_focus('qty');
			return;
		}
	
                //get_purchase_minium_price();

                $order_unit_price_discount = input_num('order_unit_price_discount');
                $order_unit_price = input_num('order_unit_price');
                $price = ($order_unit_price * (1-$order_unit_price_discount/100))/$convesion_factor;

                $po_cart->update_order_item($_POST['line_no'], input_num('tran_qty')*$convesion_factor, $price, @$_POST['req_del_date'], 
                                    $_POST['item_description'], input_num('tran_qty'),
                                    input_num('minimum_price'),  
                                    $_POST['min_price_supplier_id'], $order_unit_price);

                $po_cart->line_items[$id]->tran_unit = $_POST['tran_unit'];
                $po_cart->line_items[$id]->order_unit_price_discount = $order_unit_price_discount;
                $po_cart->line_items[$id]->minimum_price_discount = input_num('minimum_price_discount');
                $po_cart->line_items[$id]->project_site_id = $_POST['project_site_id'];

                $project_site_name = get_project_site_name($po_cart->line_items[$id]->project_site_id);
                $po_cart->line_items[$id]->project_site_name = $project_site_name;
                $po_cart->line_items[$id]->tax_group_id = $_POST['supplier_tax_group_id'];                
                $po_cart->line_items[$id]->tax_included = $_SESSION['PO']->tax_included;
                $po_cart->line_items[$id]->line_comment = $_POST['line_comment'];
                

                unset_form_variables();

                line_start_focus();
	}	
    
    
}

//---------------------------------------------------------------------------------------------------

function handle_add_new_item()
{
	$allow_update = check_data();
	
	if ($allow_update == true)
	{ 
		if (count($_SESSION['PO']->line_items) > 0)
		{
                        foreach ($_SESSION['PO']->line_items as $order_item) 
                        {
                            /* do a loop round the items on the order to see that the item
                            is not already on this order */
                                if (($order_item->stock_id == $_POST['stock_id'])) 
                                {
                                            display_warning(_("The selected item is already on this order."));
                                }
                        } /* end of the foreach loop to look for pre-existing items of the same code */
		}

		if ($allow_update == true)
		{
			$result = get_short_info($_POST['stock_id']);

			if (db_num_rows($result) == 0){
				$allow_update = false;
			}

			if ($allow_update)
			{
				$myrow = db_fetch($result);
                                get_convertion_factor2($_POST['stock_id'], $_POST['tran_unit'], $conversion_factor);

                                //$min_price = get_purchase_minimum_price($_POST['stock_id'], $_POST['tran_unit'], $_POST['req_del_date'], $_POST['project_id']);

                                $minimum_price = 0;
                                $minimum_price_discount = 0;
                                $min_price_sup_id = 0;
                                $min_price = get_purchase_minimum_price(get_post('stock_id'), $_POST['project_id'], $_POST['tran_unit'], 
                                        isset($_POST['req_del_date']) ? $_POST['req_del_date']: $_POST['OrderDate']);    
                                if(isset($min_price['price'])){
                                    $minimum_price = $min_price['price'];
                                    $minimum_price_discount = $min_price['discount'];
                                    $min_price_sup_id = $min_price['supplier_id'];
                                }
                                $order_unit_price = input_num('order_unit_price');
                                $order_unit_price_discount = input_num('order_unit_price_discount');

                                $price = ($order_unit_price * (1-$order_unit_price_discount/100))/$conversion_factor;
                                $new_line_no = count($_SESSION['PO']->line_items);
                
				$_SESSION['PO']->add_to_order ($new_line_no, $_POST['stock_id'],
//                                                input_num('qty'), 
                                                input_num('tran_qty')*$conversion_factor,
                                                get_post('stock_id_text'), //$myrow["description"], 
                                                $price, $_POST['tran_unit'], 
                                                $_SESSION['PO']->trans_type == ST_PURCHORDER ? $_POST['req_del_date'] : '', 
                                                0, 0, 0, 0, 0,
                                                $_POST['tran_unit'], input_num('tran_qty'), $conversion_factor, 
                                                $minimum_price, $min_price_sup_id, $order_unit_price);
                        

                                $_SESSION['PO']->line_items[$new_line_no]->order_unit_price_discount = $order_unit_price_discount;
                                $_SESSION['PO']->line_items[$new_line_no]->minimum_price_discount = $minimum_price_discount;
                                $_SESSION['PO']->line_items[$new_line_no]->project_site_id = $_POST['project_site_id'];
                                $project_site_name = get_project_site_name($_SESSION['PO']->line_items[$new_line_no]->project_site_id);
                                $_SESSION['PO']->line_items[$new_line_no]->project_site_name = $project_site_name;       
                                $_SESSION['PO']->line_items[$new_line_no]->tax_group_id = $_POST['supplier_tax_group_id'];
                                $_SESSION['PO']->line_items[$new_line_no]->tax_included = $_SESSION['PO']->tax_included;                                
                                $_SESSION['PO']->line_items[$new_line_no]->line_comment = $_POST['line_comment'];
        
        
        
				unset_form_variables();
				$_POST['stock_id']	= "";
	   		} 
	   		else 
	   		{
                                display_error(_("The selected item does not exist or it is a kit part and therefore cannot be purchased."));
		   	}

		} /* end of if not already on the order and allow input was true*/
        }
        $adj = &$_SESSION['PO'];
        if(count($adj->line_items) > 0 && !isset($adj->temp_supplier_id)){
                $adj->temp_supplier_id = $_POST['supplier_id'];
        }
        elseif(isset($adj->temp_supplier_id) && $adj->temp_supplier_id != $_POST['supplier_id']){
                $adj->temp_supplier_id = $_POST['supplier_id'];
        }
    
	line_start_focus();
}

//---------------------------------------------------------------------------------------------------

function can_commit()
{
	global $Refs;

	if (!get_post('supplier_id')) 
	{
		display_error(_("There is no supplier selected."));
		set_focus('supplier_id');
		return false;
	} 
    
    if (get_post('project_id') < 1) 
	{
		display_error(_("There is no project selected."));
		set_focus('project_id');
		return false;
	}
    

    
//    if (!get_post('task_id')) 
//	{
//		display_error(_("There is no budget selected."));
//		set_focus('task_id');
//		return false;
//	}
	
	if (!is_date($_POST['OrderDate'])) 
	{
		display_error(_("The entered order date is invalid."));
		set_focus('OrderDate');
		return false;
	} 
	
        if ($_SESSION['PO']->trans_type == ST_PURCHORDER){
            if($_SESSION['PO']->order_no > 0){
                $po_info = get_po_edit_info($_SESSION['PO']->order_no);
//                if($po_info['approval_status'] == AS_APPROVED || $po_info['approval_status'] == AS_REJECTED)
                if(!($po_info['approval_status'] == AS_NEW || $po_info['approval_status'] == AS_AWAITING_APPROVAL 
                    || $po_info['approval_status'] == AS_WITH_THE_APPROVER || $po_info['approval_status'] == AS_BACK_TO_ORIGINATOR 
                    || $po_info['approval_status'] == AS_REOPENED))
                {
                    display_error("This Purchase Order has been approved or rejected already. Further updating not allowed.");
                    return false;
                }

                $ced_msg = can_edit_document($_SESSION['PO']->trans_type, $_SESSION['PO']->project_id, $_SESSION['PO']->next_approval_group_id, 
                                    $_SESSION['wa_current_user']->user, $_SESSION['PO']->created_by);
                if($ced_msg['success'] !== true){
                    display_error( $ced_msg['message']);
                    set_focus('issuing_location');
                    return false;
                }
            }
        }

	if ($_SESSION['PO']->trans_type != ST_PURCHORDER && !is_date_in_fiscalyear($_POST['OrderDate'])) 
	{
		display_error(_("The entered date is not in fiscal year"));
		set_focus('OrderDate');
		return false;
	}

	if (($_SESSION['PO']->trans_type==ST_SUPPINVOICE) && !is_date($_POST['due_date'])) 
	{
		display_error(_("The entered due date is invalid."));
		set_focus('due_date');
		return false;
	} 
	
        if (!$Refs->is_valid(get_post('ref'))) 
        {
                display_error(_("There is no reference entered for this purchase order."));
                set_focus('ref');
                return false;
        } 
        
//	if (!$_SESSION['PO']->order_no) 
//	{
            

//            if (!is_new_reference(get_post('ref'), $_SESSION['PO']->trans_type)) 
//            {
//                    display_error(_("The entered reference is already in use."));
//                    set_focus('ref');
//                    return false;
//            }
        
        $ref_msg = reference_exists(get_post('ref'), $_SESSION['PO']->trans_type, $_SESSION['PO']->order_no);
        if($ref_msg){
                display_error(_($ref_msg));
                set_focus('ref');
                return false;
        }
	
	
	if ($_SESSION['PO']->trans_type == ST_SUPPINVOICE && !$Refs->is_valid(get_post('supp_ref'))) 
	{
		display_error(_("You must enter a supplier's invoice reference."));
		set_focus('supp_ref');
		return false;
	}
	if ($_SESSION['PO']->trans_type==ST_SUPPINVOICE 
		&& is_reference_already_there($_SESSION['PO']->supplier_id, get_post('supp_ref'), $_SESSION['PO']->order_no))
	{
		display_error(_("This invoice number has already been entered. It cannot be entered again.") . " (" . get_post('supp_ref') . ")");
		set_focus('supp_ref');
		return false;
	}
	if ($_SESSION['PO']->trans_type == ST_PURCHORDER && get_post('delivery_address') == '')
	{
		display_error(_("There is no delivery address specified."));
		set_focus('delivery_address');
		return false;
	} 
	if (get_post('StkLocation') == '')
	{
		display_error(_("There is no location specified to move any items into."));
		set_focus('StkLocation');
		return false;
	} 
	if (!db_has_currency_rates($_SESSION['PO']->curr_code, $_POST['OrderDate']))
		return false;
        
	if ($_SESSION['PO']->order_has_items() == false)
	{
            display_error (_("The order cannot be placed because there are no lines entered on this order."));
            return false;
	}
        
    if ($_SESSION['PO']->trans_type == ST_SUPPRECEIVE || $_SESSION['PO']->trans_type == ST_SUPPINVOICE)
	{
            if($_SESSION['wa_current_user']->po_approval_limit < $_SESSION['PO']->get_trans_total())
            {
                display_error (_("Your PO approval limit of ".number_format($_SESSION['wa_current_user']->po_approval_limit,2)." is not sufficient to create this document. Please create a purchase order and request approval."));
                return false;
            }
	}
		
	return true;
}


//---------------------------------------------------------------------------------------------------

function set_approval_status(&$cart)
{
//    if($cart->approval_status == "")
//        $cart->approval_status = "N";
//    elseif($cart->approval_status == "R")
//        $cart->approval_status = "U";
}

//---------------------------------------------------------------------------------------------------

function approve_po($po_no, $cart)
{
    $current_user_id = $_SESSION['wa_current_user']->user;
    
    $po_total = calculate_po_remaining_total($cart->line_items);
    
    $cart->row_state = db_new_row_state($cart->row_state);
    
    $info = approve_document(ST_PURCHORDER, $po_no, $cart->project_id, 
                        $po_total, $cart->next_approval_group_id, 
                        $current_user_id, $cart->row_state);

    if($info['success'] !== true){
        cancel_transaction();
        return array("success" => $info['success'], "message" => $info['message']);
    }

    /* Budget allocation is in the Purchase Requisition
     * PO requires approval only
     */
//    if($info['approval_status'] == AS_APPROVED){            
//        $apc_msg = allocate_to_task(ST_PURCHORDER, $po_no, 
//                        $cart->task_id, $po_total, 
//                        $current_user_id);
//        if($apc_msg['success'] !== true){
//            cancel_transaction();
//            return array("success" => $apc_msg['success'], "message" => $info['msg']);
//        }
//    }
    
    return array("success" => true, "message" => $info['message']);
            
        
}
//---------------------------------------------------------------------------------------------------

function handle_commit_order($release = false)
{
	$cart = &$_SESSION['PO'];

	if (can_commit()) {

		copy_to_cart();
        //set_approval_status($cart);
                
		if ($cart->trans_type != ST_PURCHORDER) {
			// for direct grn/invoice set same dates for lines as for whole document
			foreach ($cart->line_items as $line_no =>$line)
				$cart->line_items[$line_no]->req_del_date = $cart->orig_order_date;
		}
		if ($cart->order_no == 0) { // new po/grn/invoice
			/*its a new order to be inserted */
			$ref = $cart->reference;
			if ($cart->trans_type != ST_PURCHORDER) {
				$cart->reference = 'auto';
				begin_transaction();	// all db changes as single transaction for direct document
			}
                        
                        $cart->taxes = $cart->get_taxes(input_num('freight_cost'));
			$apo_msg = add_po($cart);
                        if($apo_msg['success'] !== true){
                                cancel_transaction();
                                display_error($apo_msg['message']);
                                return;
                        }
                        else{
                                $order_no = $apo_msg['tran_no'];
                        }
                        
			new_doc_date($cart->orig_order_date); 
                        $cart->order_no = $order_no;

			if ($cart->trans_type == ST_PURCHORDER) {
				unset($_SESSION['PO']);
                                meta_forward($_SERVER['PHP_SELF'], "AddedID=$order_no");
//                                return;
                        }
			//Direct GRN
			if ($cart->trans_type == ST_SUPPRECEIVE)
				$cart->reference = $ref;
			if ($cart->trans_type != ST_SUPPINVOICE)	
				$cart->Comments = $cart->reference; //grn does not hold supp_ref
			foreach($cart->line_items as $key => $line)
				$cart->line_items[$key]->receive_qty = $line->quantity;
			$grn_no = add_grn($cart);
			if ($cart->trans_type == ST_SUPPRECEIVE) {
				commit_transaction(); // save PO+GRN
                                //sleep(60);
				unset($_SESSION['PO']);
        		meta_forward($_SERVER['PHP_SELF'], "AddedGRN=$grn_no");
			}
//			Direct Purchase Invoice
 			$inv = new supp_trans(ST_SUPPINVOICE);
			$inv->Comments = $cart->Comments;
			$inv->supplier_id = $cart->supplier_id;
			$inv->tran_date = $cart->orig_order_date;
			$inv->due_date = $cart->due_date;
			$inv->reference = $ref;
			$inv->supp_reference = $cart->supp_ref;
			$inv->tax_included = $cart->tax_included;
			$supp = get_supplier($cart->supplier_id);
			$inv->tax_group_id = $supp['tax_group_id'];
                        $inv->project_id = $cart->project_id;
                        $inv->task_id = $cart->task_id;

			$inv->ov_amount = $inv->ov_gst = $inv->ov_discount = 0;

			$total = 0;
			foreach($cart->line_items as $key => $line) {
				$inv->add_grn_to_trans($line->grn_item_id, $line->po_detail_rec, $line->stock_id,
					$line->item_description, $line->receive_qty, 0, $line->receive_qty,
					$line->price, $line->price, true, get_standard_cost($line->stock_id), '');
				$inv->ov_amount += round2(($line->receive_qty * $line->price), user_price_dec());
			}
			$inv->tax_overrides = $cart->tax_overrides;
			if (!$inv->tax_included) {
				$taxes = $inv->get_taxes($inv->tax_group_id, 0, false);
				foreach( $taxes as $taxitem) {
					$total += isset($taxitem['Override']) ? $taxitem['Override'] : $taxitem['Value'];
				}
			}
			$inv->ex_rate = $cart->ex_rate;

			$inv_no = add_supp_invoice($inv);
			commit_transaction(); // save PO+GRN+PI
			// FIXME payment for cash terms. (Needs cash account selection)
			unset($_SESSION['PO']);
                        meta_forward($_SERVER['PHP_SELF'], "AddedPI=$inv_no");
		}
		else { // order modification
                        if($release){
                            begin_transaction();
                        }

                        $cart->taxes = $cart->get_taxes(input_num('freight_cost'));
                        
                        $upo_msg = update_po($cart);
                        if($upo_msg['success'] != true){
                            cancel_transaction();
                            display_error($upo_msg['message']);
                            return;
                        }
                        else{
                            $order_no = $upo_msg['tran_no'];
                        }
                        if($order_no > 0){
                            if($release){
                                $ap_msg = approve_po($order_no, $cart);
                                if($ap_msg['success'] === true){
                                    commit_transaction();
                                    set_session_variable('po_messages', array('success' => true, 'message' => $ap_msg['message']));
                                }
                                else{
                                    cancel_transaction();
                                    set_session_variable('po_messages', array('success' => false, 'message' => $ap_msg['message']));
                                }
                            }
                        }
                            
			unset($_SESSION['PO']);
                        meta_forward($_SERVER['PHP_SELF'], "AddedID=$order_no&Updated=1");	
		}
	}
}

//-------------------------------------------------------------------------------

function send_po_back_to_originator()
{
    if(!can_commit()){
        return;
    }
    
    $po = $_SESSION['PO'];
    $current_user_id = $_SESSION['wa_current_user']->user;
    
    $sbdo_msg = send_back_to_document_originator($po->trans_type, $po->order_no, $po->project_id,
                                    $po->next_approval_group_id, $current_user_id, $po->row_state, 
                                    $po->created_by);
    
    if($sbdo_msg['success'] !== true){
        cancel_transaction();
        display_error($sbdo_msg['message']);
    }
    else{
        $trans_no = $sbdo_msg['tran_no'];
        new_doc_date($_POST['OrderDate']);
        $_SESSION['PO']->clear_items();
        unset($_SESSION['PO']);
        set_session_variable('po_messages', array('success' => true, 'message' => $sbdo_msg['message']));
        
        meta_forward($_SERVER['PHP_SELF'], "AddedID=$trans_no");
    }

}
//-------------------------------------------------------------------------------

function reject_po()
{
    if(!can_commit()){
        return;
    }
    
    $po = $_SESSION['PO'];
    $current_user_id = $_SESSION['wa_current_user']->user;
    
    begin_transaction();
    $sbdo_msg = reject_document($po->trans_type, $po->order_no, $po->project_id,
                    $po->next_approval_group_id, $current_user_id, $po->row_state);
    
    if($sbdo_msg['success'] !== true){
        cancel_transaction();
        display_error($sbdo_msg['message']);
    }
    else{
        commit_transaction();
        $trans_no = $sbdo_msg['tran_no'];
        new_doc_date($_POST['OrderDate']);
        $_SESSION['PO']->clear_items();
        unset($_SESSION['PO']);
        set_session_variable('po_messages', array('success' => true, 'message' => "Purchase order ".$sbdo_msg['tran_no']." has been rejected."));
        
        meta_forward($_SERVER['PHP_SELF'], "AddedID=$trans_no");
    }

}


//---------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------

if (isset($_POST['Back_To_Originator'])){

    send_po_back_to_originator();
        
} 


//-------------------------------------------------------------------------------

if (isset($_POST['Reject_PO'])){

    reject_po();
        
} 


//-------------------------------------------------------------------------------


$id = find_submit('Delete');
if ($id != -1)
	handle_delete_item($id);

if (isset($_POST['Commit']))
{
	handle_commit_order();
}

if (isset($_POST['Release']))
{
//        if($_SESSION['wa_current_user']->po_approval_limit >= $_SESSION['PO']->get_trans_total()){
//            $_SESSION['PO']->approval_status = "A";
//        }
//        else{
//            $_SESSION['PO']->approval_status = "L";
//        }
        handle_commit_order(true);
}

if (isset($_POST['UpdateLine']))
	handle_update_item();

if (isset($_POST['EnterLine']))
	handle_add_new_item();

if (isset($_POST['CancelOrder'])) 
	handle_cancel_po();

if (isset($_POST['CancelUpdate']))
	unset_form_variables();

if (isset($_POST['CancelUpdate']) || isset($_POST['UpdateLine'])) {
	line_start_focus();
}



//---------------------------------------------------------------------------------------------------

start_form();

display_po_header($_SESSION['PO']);
echo "<br>";

display_po_items($_SESSION['PO']);

$msg = check_po_class_purchase_order_integrity($_SESSION['PO']->order_no);
if($msg['success'] !== true){
    display_error($msg['message']);
}

start_table(TABLESTYLE2);
textarea_row(_("Memo:"), 'Comments', null, 70, 4);

end_table(1);

div_start('controls', 'items_table');

$process_txt = _("Place Order");
$update_txt = _("Update Order");
$release_txt = _("Release for Approval");
$cancel_txt = _("Cancel");

if ($_SESSION['PO']->trans_type == ST_SUPPRECEIVE) {
	$process_txt = _("Process GRN");
	$update_txt = _("Update GRN");
	$cancel_txt = _("Cancel");
}	
elseif ($_SESSION['PO']->trans_type == ST_SUPPINVOICE) {
	$process_txt = _("Process Invoice");
	$update_txt = _("Update Invoice");
	$cancel_txt = _("Cancel Invoice");
}	

if ($_SESSION['PO']->order_has_items()) 
{
	if ($_SESSION['PO']->order_no){
            submit_center_first('Commit', $update_txt, '', 'default');
            submit('Release', $release_txt, true, '', 'default');
            submit_center_last('CancelOrder', $cancel_txt, _("Cancel Edition"), 'cancel');
        
        if ($_SESSION['PO']->trans_type == ST_PURCHORDER){
            br();
            submit_center_first('Back_To_Originator', "Back To Originator", '', 'default');
            submit_center_last('Reject_PO', "Reject", '', 'default');
        }
    }
	else{
		//submit_center_first('Commit', $process_txt, '', 'default');
                //submit('Commit', $process_txt, true, '', 'default');
        submit("Commit", $process_txt );
        submit_center_last('CancelOrder', $cancel_txt); 
    }
		
}
else
	submit_center('CancelOrder', $cancel_txt, true, false, 'cancel');
div_end();
//---------------------------------------------------------------------------------------------------

end_form();
end_page();
?>
